c     $Header: /numrelcvs/AEIThorns/BSSN_MoL/src/Constraints.F,v 1.8 2005/10/05 15:03:23 schnetter Exp $

#include "cctk.h"
#include "cctk_Arguments.h"
#include "cctk_Functions.h"
#include "cctk_Parameters.h"

      subroutine ADM_BSSN_Constraints (CCTK_ARGUMENTS)
      implicit none
      DECLARE_CCTK_ARGUMENTS
      DECLARE_CCTK_FUNCTIONS
      DECLARE_CCTK_PARAMETERS
      
      CCTK_INT,  parameter :: ione=1
      CCTK_REAL, parameter :: two=2, twothird=two/3
      CCTK_INT,  parameter :: faces=CCTK_ALL_FACES
      
      integer i,j,k
      integer ierr
      logical is_active
      
#include "CactusEinstein/ADMMacros/src/macro/ADM_Spacing_declare.h"
#include "macro/BSUPPERMET_declare.h"
#include "macro/BSCHR2_declare.h"
#include "macro/BSDETG_declare.h"
#include "macro/BSHAMSTD_declare.h"
#include "macro/BSMOMSTD_declare.h"
      
      do k=2,cctk_lsh(3)-1
         do j=2,cctk_lsh(2)-1
            do i=2,cctk_lsh(1)-1
               
               is_active = excise==0
               if (.not.is_active) then
                  is_active = use_mask==0
               end if
               if (.not.is_active) then
                  is_active = emask(i,j,k) > 0.75
               end if
               
               if (is_active) then
                  
                  if (spatial_order > 2) then
                     if ( i<3 .or. i>cctk_lsh(1)-2 .or.
     $                    j<3 .or. j>cctk_lsh(2)-2 .or.
     $                    k<3 .or. k>cctk_lsh(3)-2) then
                        local_spatial_order = 2
                     else
                        if (use_mask > 0) then
                           if (minval(emask(i-2:i+2,j-2:j+2,k-2:k+2)) < 0.75d0) then
                              local_spatial_order = 2
                           else
                              local_spatial_order = spatial_order
                           end if
                        else
                           local_spatial_order = spatial_order
                        end if
                     end if
                  end if

#include "macro/BSUPPERMET_guts.h"
#include "macro/BSCHR2_guts.h"

            ADM_BS_dGx(i,j,k) = ADM_BS_Gx(i,j,k) -
     +         ( BSUPPERMET_UXX * BSCHR2_XXX +
     +           BSUPPERMET_UYY * BSCHR2_XYY +
     +           BSUPPERMET_UZZ * BSCHR2_XZZ +
     +           2.0 * (BSUPPERMET_UXY * BSCHR2_XXY +
     +                  BSUPPERMET_UXZ * BSCHR2_XXZ +
     +                  BSUPPERMET_UYZ * BSCHR2_XYZ))
     
            ADM_BS_dGy(i,j,k) = ADM_BS_Gy(i,j,k) -
     +         ( BSUPPERMET_UXX * BSCHR2_YXX +
     +           BSUPPERMET_UYY * BSCHR2_YYY +
     +           BSUPPERMET_UZZ * BSCHR2_YZZ +
     +           2.0 * (BSUPPERMET_UXY * BSCHR2_YXY +
     +                  BSUPPERMET_UXZ * BSCHR2_YXZ +
     +                  BSUPPERMET_UYZ * BSCHR2_YYZ))

            ADM_BS_dGz(i,j,k) = ADM_BS_Gz(i,j,k) -
     +         ( BSUPPERMET_UXX * BSCHR2_ZXX +
     +           BSUPPERMET_UYY * BSCHR2_ZYY +
     +           BSUPPERMET_UZZ * BSCHR2_ZZZ +
     +           2.0 * (BSUPPERMET_UXY * BSCHR2_ZXY +
     +                  BSUPPERMET_UXZ * BSCHR2_ZXZ +
     +                  BSUPPERMET_UYZ * BSCHR2_ZYZ))

#include "macro/BSHAMSTD_guts.h"
                  ADM_BS_ham(i,j,k) = BSHAMSTD_HAM

#include "macro/BSMOMSTD_guts.h"
                  ADM_BS_momx(i,j,k) = BSMOMSTD_MOMX
                  ADM_BS_momy(i,j,k) = BSMOMSTD_MOMY
                  ADM_BS_momz(i,j,k) = BSMOMSTD_MOMZ
                  
               else
                  
                  ADM_BS_dGx(i,j,k) = 0
                  ADM_BS_dGy(i,j,k) = 0
                  ADM_BS_dGz(i,j,k) = 0

                  ADM_BS_ham(i,j,k) = 0
                  
                  ADM_BS_momx(i,j,k) = 0
                  ADM_BS_momy(i,j,k) = 0
                  ADM_BS_momz(i,j,k) = 0
                  
               end if
               
            end do
         end do
      end do
      
#include "macro/BSUPPERMET_undefine.h"
#include "macro/BSCHR2_undefine.h"
#include "macro/BSDETG_undefine.h"
#include "macro/BSHAMSTD_undefine.h"
#include "macro/BSMOMSTD_undefine.h"
      
      ierr = Boundary_SelectGroupForBC
     $     (cctkGH, CCTK_ALL_FACES, ione, -ione,
     $     "ADM_BSSN::ADM_BSSN_cons", "Flat")
      if (ierr/=0) call CCTK_WARN(0, "error trying to select Flat BC for ADM_BSSN::ADM_BSSN_cons")
      
      end subroutine ADM_BSSN_Constraints
